#include <tigcclib.h>
#define maxr 20
#define maxc 30
#define full &(SCR_RECT){{0,0,159,99}}
enum keys {Eenter=13,Eback=257,Eclear=263,Eescape,Eapps,Emode,Ef1=268,Ef2,Ef3,Ef4,Ef5,Ef6,Ef7,Ef8,Ehome=277,Ecatalog,Eup=337,Eleft,Eleftup,Edown,Eupdown,Eleftdown,Eleftupdown,Eright,Eupright,Eleftright,Eleftupright,Erightdown,Euprightdown,Eleftdownright,Euprightleftdown,E2nddimondalpha,Edimondalpha=380,E2nddimondshiftalpha=384,E2ndescape=4360,E2ndup=4433,E2ndleft,E2ndleftup,E2nddown,E2ndupdown,E2ndleftdown,E2ndrightupdown,E2ndright,E2ndupright,E2ndleftright,E2ndleftupright,E2ndrightdown,E2nduprightdown,E2ndleftdownright,E2nduprightleftdown,Edimondenter=16397,Edimondback=16641,Edimondclear=16647,Edimondescape,Edimondapps,Edimondmode,Edimondup=16721,Edimondleft,Edimondleftup,Edimonddown,Edimondupdown,Edimondleftdown,Edimondrightupdown,Edimondright,Edimondupright,Edimondleftright,Edimondleftupright,Edimondrightdown,Edimonduprightdown,Edimondleftdownright,Edimonduprightleftdown};
enum pieces {SPACE,DMR,DML,WALL,BLOCK,DOOR};
INT_HANDLER oldint5=NULL;
int tick;
typedef struct {
	unsigned char numr;
	unsigned char numc;
	unsigned char data[maxr][maxc];
	unsigned char pass[4];
} level;
typedef struct {
	char dir;
	unsigned char row;
	unsigned char col;
	unsigned char holding;
} player;
typedef struct {
	unsigned char row;
	unsigned char col;
} cell;
DEFINE_INT_HANDLER (myint5handler) {
	tick++;
    ExecuteHandler(oldint5);
}
char fname[18],pname[30];
unsigned char block[]={0xff,0x81,0x81,0x81,0x81,0x81,0x81,0xff};
unsigned char door[] ={0x7e,0x42,0x42,0x42,0x46,0x42,0x42,0x7e};
unsigned char dmanl[]={0x1c,0x7e,0x12,0x22,0x14,0x2a,0x08,0x36};
unsigned char dmanr[]={0x38,0x7e,0x48,0x44,0x28,0x54,0x10,0x6c};
unsigned char wall[] ={0xfb,0xfb,0x00,0xfe,0xfe,0x00,0xfb,0xfb};
unsigned char loadlevel(unsigned char l),move(int k),start;
int editmenu();
void disp(unsigned char r,unsigned char c),editor(),load(),message(const char *str),play(unsigned char pass),save(),setcam();
cell cam;
level clevel;
player dm;
void _main(void) {
	int k,moves[]={Eleft,Edown,Eleft,Edown,Eup,Eup,Eleft,Edown,Eleft,Eleft,Eup,Eleft,Eleft,Edown,Eup,Eup,Eleft,Eleft};
	short olddelay;
	unsigned char a,exit,m,p;
	oldint5=GetIntVec(AUTO_INT_5);
	sprintf(fname,"orgnlvls");
	SetIntVec(AUTO_INT_5,myint5handler);
	olddelay=OSInitKeyInitDelay(48);
	p=0;
	while (p!=3) {
		m=0;
		p=0;
		exit=0;
		start=0;
		pname[0]=0;
		a=loadlevel(0);
		start=1;
		start=loadlevel(0);
		while (!exit) {
			disp(0,0);
			FontSetSys(F_4x6);
			DrawStr(0,95,"Press CLEAR to change level pack",A_NORMAL);
			if (a) {
				DrawStr(0,89,"Current level pack -",A_NORMAL);
				DrawStr(72,89,pname,A_NORMAL);
			}
			else
				printf_xy(0,95,"File %s not found.",fname);
			FontSetSys(F_6x8);
			DrawStr(7,60,"New Password Editor Exit",A_NORMAL);
			switch (p) {
				case 0:ScrRectFill(&(SCR_RECT){{7,59,25,67}},full,A_XOR);break;
				case 1:ScrRectFill(&(SCR_RECT){{31,59,79,67}},full,A_XOR);break;
				case 2:ScrRectFill(&(SCR_RECT){{85,59,121,67}},full,A_XOR);break;
				case 3:ScrRectFill(&(SCR_RECT){{127,59,151,67}},full,A_XOR);break;
			}
			tick=0;
			while (tick<10) {
				if (kbhit()) {
					k=ngetchx();
					switch (k) {
						case Eescape:p=3;
						case Eenter:exit=1;tick=10;break;
						case Eleft:
							switch (p) {
								case 0:ScrRectFill(&(SCR_RECT){{7,59,25,67}},full,A_XOR);break;
								case 1:ScrRectFill(&(SCR_RECT){{31,59,79,67}},full,A_XOR);break;
								case 2:ScrRectFill(&(SCR_RECT){{85,59,121,67}},full,A_XOR);break;
								case 3:ScrRectFill(&(SCR_RECT){{127,59,151,67}},full,A_XOR);break;
							}
							if (p==0)
								p=3;
							else
								p--;
							switch (p) {
								case 0:ScrRectFill(&(SCR_RECT){{7,59,25,67}},full,A_XOR);break;
								case 1:ScrRectFill(&(SCR_RECT){{31,59,79,67}},full,A_XOR);break;
								case 2:ScrRectFill(&(SCR_RECT){{85,59,121,67}},full,A_XOR);break;
								case 3:ScrRectFill(&(SCR_RECT){{127,59,151,67}},full,A_XOR);break;
							}
							break;
						case Eright:
							switch (p) {
								case 0:ScrRectFill(&(SCR_RECT){{7,59,25,67}},full,A_XOR);break;
								case 1:ScrRectFill(&(SCR_RECT){{31,59,79,67}},full,A_XOR);break;
								case 2:ScrRectFill(&(SCR_RECT){{85,59,121,67}},full,A_XOR);break;
								case 3:ScrRectFill(&(SCR_RECT){{127,59,151,67}},full,A_XOR);break;
							}
							if (p==3)
								p=0;
							else
								p++;
							switch (p) {
								case 0:ScrRectFill(&(SCR_RECT){{7,59,25,67}},full,A_XOR);break;
								case 1:ScrRectFill(&(SCR_RECT){{31,59,79,67}},full,A_XOR);break;
								case 2:ScrRectFill(&(SCR_RECT){{85,59,121,67}},full,A_XOR);break;
								case 3:ScrRectFill(&(SCR_RECT){{127,59,151,67}},full,A_XOR);break;
							}
							break;
						case Eclear:
							clrscr();
							printf("File name: ");
							getsn(fname,18);
							p=4;
							exit=1;
							break;
					}
				}
			}
			if (m==18) {
				loadlevel(0);
				m=0;
			}
			if (start)move(moves[m]);
			m++;
		}
		start=0;
		switch (p) {
			case 0:
			case 1:play(p);break;
			case 2:editor();break;
		}
	}
	SetIntVec(AUTO_INT_5,oldint5);
	OSInitKeyInitDelay(olddelay);
}
int editmenu() {
	int k;
	clrscr();
	printf("1 - Save\n2 - Load\n3 - Exit (without Saving)\n4 - Return\n5 - Help");
	do k=ngetchx();while ((k<'1'||k>'5')&&k!=Eescape);
	switch (k) {
		case '1':save();break;
		case '2':load();break;
		case '3':return Eescape;break;
		case '5':
			clrscr();
			printf("F1/1 -\nF2/2 -\nF3/3 -\nF4/4 -\nF5/5 - Resize level\n0/CLEAR - Clears piece");
			Sprite8(42,0,8,dmanr,LCD_MEM,SPRT_XOR);
			Sprite8(42,8,8,wall,LCD_MEM,SPRT_XOR);
			Sprite8(42,16,8,block,LCD_MEM,SPRT_XOR);
			Sprite8(42,24,8,door,LCD_MEM,SPRT_XOR);
			ngetchx();
			break;
	}
	return 0;
}
unsigned char loadlevel(unsigned char l) {
	FILE *f1;
	unsigned char a,c,r;
	if (start)
		f1=fopen("orgnlvls","rb");
	else
		f1=fopen(fname,"rb");
	if (!f1)
		return 0;
	c=0;
	do {
		a=fgetc(f1);
		if (!start)
			pname[c]=a;
		c++;
	} while (a);
	if (l>=fgetc(f1))
		return 0;
	while (l>0) {
		clevel.numr=fgetc(f1);
		clevel.numc=fgetc(f1);
		fseek(f1,clevel.numr*((clevel.numc+(clevel.numc%2))/2)+3,SEEK_CUR);
		l--;
	}
	clevel.numr=fgetc(f1);
	clevel.numc=fgetc(f1);
	fread(clevel.pass,1,3,f1);
	clevel.pass[3]=0;
	for (r=0;r<clevel.numr;r++) {
		for (c=0;c<clevel.numc;c+=2) {
			a=fgetc(f1);
			clevel.data[r][c]=(a&240)>>4;
			clevel.data[r][c+1]=a&15;
			if ((a&240)>>4==1) {
				dm.row=r;
				dm.col=c;
				dm.dir=1;
			}
			if ((a&240)>>4==2) {
				dm.row=r;
				dm.col=c;
				dm.dir=-1;
			}
			if ((a&15)==1) {
				dm.row=r;
				dm.col=c+1;
				dm.dir=1;
			}
			if ((a&15)==2) {
				dm.row=r;
				dm.col=c+1;
				dm.dir=-1;
			}
		}
	}
	fclose(f1);
	return 1;
}
unsigned char move(int k) {
	unsigned char a;
	switch (k) {
		case Eright:
			dm.dir=1;
			if (dm.col==clevel.numc-1)
				break;
		case Eleft:
			if (k==Eleft) {
				dm.dir=-1;
				if (dm.col==0)
					break;
			}
			if (clevel.data[dm.row][dm.col+dm.dir]==DOOR) // if dudeman ran into a door
				return 1;
			if (clevel.data[dm.row][dm.col+dm.dir]==0) { // if the space in front of dudeman is empty
				clevel.data[dm.row][dm.col]=0;
				if (dm.holding) {
					clevel.data[dm.row-1][dm.col]=0;
					if (clevel.data[dm.row-1][dm.col+dm.dir]) {
						dm.holding=0;
						clevel.data[dm.row][dm.col]=BLOCK;
					}
				}
				dm.col+=dm.dir;
				while (!clevel.data[dm.row+1][dm.col]) { // while there is no floor under dudeman and he's in the level
					dm.row++;
					if (dm.row>=clevel.numr-1) // if dudeman fell out of the level
						return 2;
					if (clevel.data[dm.row+1][dm.col]==DOOR) // if dudeman fell on a door
						return 1;
				}
				if (clevel.data[dm.row+1][dm.col]==DOOR)
					return 1;
				clevel.data[dm.row][dm.col]=1+(dm.dir==-1);
				if (dm.holding)
					clevel.data[dm.row-1][dm.col]=BLOCK;
			}
			break;
		case Eup:
			if (dm.row>0&&clevel.data[dm.row][dm.col+dm.dir]) { // if there is something in front of dudeman
				if (clevel.data[dm.row-1][dm.col+dm.dir]==DOOR) // if dudeman climbs into a door
					return 1;
				if (dm.holding) { // if dudeman is holding a block
					if (dm.row<1||clevel.data[dm.row-2][dm.col+dm.dir])
						break;
				}
				if (!clevel.data[dm.row-1][dm.col+dm.dir]) { // if there is nothing on top of whatever's in front of dudeman
					clevel.data[dm.row][dm.col]=0;
					if (dm.holding)
						clevel.data[dm.row-1][dm.col]=0;
					dm.row--;
					dm.col+=dm.dir;
					clevel.data[dm.row][dm.col]=1+(dm.dir==-1);
					if (dm.holding)
						clevel.data[dm.row-1][dm.col]=BLOCK;
				}
			}
			break;
		case Edown:
			if (dm.holding) {
				if (dm.col+dm.dir>=0&&dm.col+dm.dir<=clevel.numc-1&&!clevel.data[dm.row-1][dm.col+dm.dir]) { // if there is nothing in the way of the block
					dm.holding=0;
					clevel.data[dm.row-1][dm.col]=0;
					if (!clevel.data[dm.row][dm.col+dm.dir]) { // if there is nothing in fornt of dudeman
						a=dm.row+1;
						while (a<clevel.numr&&!clevel.data[a][dm.col+dm.dir]) // moves the block down until it hits the floor
							a++;
						if (a<clevel.numr)
							clevel.data[a-1][dm.col+dm.dir]=BLOCK;
					}
					else
						clevel.data[dm.row-1][dm.col+dm.dir]=BLOCK;
				}
			}
			else {
				if (clevel.data[dm.row][dm.col+dm.dir]==BLOCK&&!clevel.data[dm.row-1][dm.col+dm.dir]&&!clevel.data[dm.row-1][dm.col]) {
					dm.holding=1;
					clevel.data[dm.row][dm.col+dm.dir]=0;
					clevel.data[dm.row-1][dm.col]=BLOCK;
				}
			}
			break;
	}
	return 0;
}
unsigned char playlevel() {
	int k=0;
	while (k!=Eescape) {
		clevel.data[dm.row][dm.col]=1+(dm.dir==-1);
		setcam();
		disp(cam.row,cam.col);
		k=ngetchx();
		switch (k) {
			case Eright:
			case Eleft:
			case Eup:
			case Edown:
				switch (move(k)) {
					case 1:return 1;break;
					case 2:return 2;break;
				}
				break;
			case Eclear:
				return 2;
				break;
		}
	}
	return 0;
}
void disp(unsigned char r,unsigned char c) {
	unsigned char a,b;
	char *sprt=NULL;
	clrscr();
	for (a=r;a<r+12&&a<clevel.numr;a++) {
		for (b=c;b<c+20&&b<clevel.numc;b++) {
			switch (clevel.data[a][b]) {
				case 0:sprt=NULL;break;
				case 1:sprt=dmanr;break;
				case 2:sprt=dmanl;break;
				case 3:sprt=wall;break;
				case 4:sprt=block;break;
				case 5:sprt=door;break;
			}
			if (sprt)
				Sprite8(8*(b-c),8*(a-r),8,sprt,LCD_MEM,SPRT_XOR);
		}
	}
}
void editor() {
	cell cam;
	int k;
	level sav;
	player psav;
	unsigned char r,c;
	clevel.numr=12;
	clevel.numc=20;
	clrscr();
	printf("Number of rows\n");
	do {
		printf_xy(90,0,"%d ",clevel.numr);
		do k=ngetchx();while (k!=Eup&&k!=Edown&&k!=Eenter);
		if (k==Eup) {
			if (clevel.numr<20)
				clevel.numr++;
		}
		else if (k==Edown) {
			if (clevel.numr>1)
				clevel.numr--;
		}
	} while (k!=Eenter);
	printf("Number of columns\n");
	do {
		printf_xy(108,8,"%d ",clevel.numc);
		do k=ngetchx();while (k!=Eup&&k!=Edown&&k!=Eenter);
		if (k==Eup) {
			if (clevel.numc<30)
				clevel.numc++;
		}
		else if (k==Edown) {
			if (clevel.numc>1)
				clevel.numc--;
		}
	} while (k!=Eenter);
	for (r=0;r<clevel.numr;r++) { // clears the level
		for (c=0;c<clevel.numc;c++)
			clevel.data[r][c]=0;
	}
	for (r=0;r<clevel.numr;r++) { // puts walls on either side
		clevel.data[r][0]=WALL;
		clevel.data[r][clevel.numc-1]=WALL;
	}
	for (r=0;r<clevel.numc;r++) { // puts the floor and ceiling
		clevel.data[0][r]=WALL;
		clevel.data[clevel.numr-1][r]=WALL;
	}
	dm.row=255;
	dm.holding=0;
	cam.row=0;
	cam.col=0;
	r=1;
	c=1;
	k=0;
	do {
		disp(cam.row,cam.col);
		while (!kbhit()) {
			tick=0;
			ScrRectFill(&(SCR_RECT){{(c-cam.col)*8,(r-cam.row)*8,(c-cam.col)*8+7,(r-cam.row)*8+7}},full,A_XOR);
			while (tick<6&&!kbhit());
			ScrRectFill(&(SCR_RECT){{(c-cam.col)*8,(r-cam.row)*8,(c-cam.col)*8+7,(r-cam.row)*8+7}},full,A_XOR);
			tick=0;
			while (tick<6&&!kbhit());
		}
		k=ngetchx();
		switch (k) {
			case Eup:
				if (r==0) {
					r=clevel.numr-1;
					if (clevel.numr>12)
						cam.row=clevel.numr-12;
				}
				else {
					r--;
					if (r-cam.row<0)
						cam.row--;
				}
				break;
			case Edown:
				if (r==clevel.numr-1) {
					r=0;
					cam.row=0;
				}
				else {
					r++;
					if (r-cam.row>11)
						cam.row++;
				}
				break;
			case Eright:
				if (c==clevel.numc-1) {
					c=0;
					cam.col=0;
				}
				else {
					c++;
					if (c-cam.col>19)
						cam.col++;
				}
				break;
			case Eleft:
				if (c==0) {
					c=clevel.numc-1;
					if (clevel.numc>20)
						cam.col=clevel.numc-20;
				}
				else {
					c--;
					if (c-cam.col<0)
						cam.col--;
				}
				break;
			case E2ndup:
				if (cam.row>0)
					cam.row--;
				if (r-cam.row>11)
					r--;
				break;
			case E2nddown:
				if (cam.row<clevel.numr-12)
					cam.row++;
				if (r-cam.row<0)
					r++;
				break;
			case E2ndright:
				if (cam.col<clevel.numc-20)
					cam.col++;
				if (c-cam.col<0)
					c++;
				break;
			case E2ndleft:
				if (cam.col>0)
					cam.col--;
				if (c-cam.col>19)
					c--;
				break;
			case Edimondup:
				if (clevel.numr>1)
					clevel.numr--;
				break;
			case Edimonddown:
				if (clevel.numr<maxr)
					clevel.numr++;
				break;
			case Edimondright:
				if (clevel.numc<maxc)
					clevel.numc++;
				break;
			case Edimondleft:
				if (clevel.numc>2)
					clevel.numc--;
				break;
			case '0':
			case Eback:
			case Eclear:
				if (clevel.data[r][c]==DMR||clevel.data[r][c]==DML)
					dm.row=255;
				clevel.data[r][c]=0;
				break;
			case '1':
			case Ef1:
				if (dm.row==255||(dm.row==r&&dm.col==c&&dm.dir==-1)) {
					clevel.data[r][c]=DMR;
					dm.row=r;
					dm.col=c;
					dm.dir=1;
				}
				else if (dm.row==r&&dm.col==c) {
					clevel.data[r][c]=DML;
					dm.dir=-1;
				}
				break;
			case '2':
			case Ef2:
				if (clevel.data[r][c]==DMR||clevel.data[r][c]==DML)
					dm.row=255;
				clevel.data[r][c]=WALL;
				break;
			case '3':
			case Ef3:
				if (clevel.data[r][c]==DMR||clevel.data[r][c]==DML)
					dm.row=255;
				clevel.data[r][c]=BLOCK;
				break;
			case '4':
			case Ef4:
				if (clevel.data[r][c]==DMR||clevel.data[r][c]==DML)
					dm.row=255;
				clevel.data[r][c]=DOOR;
				break;
			case '5':
			case Ef5:
				clrscr();
				printf("Number of rows\n");
				do {
					printf_xy(90,0,"%d ",clevel.numr);
					do k=ngetchx();while (k!=Eup&&k!=Edown&&k!=Eenter);
					if (k==Eup) {
						if (clevel.numr<20)
							clevel.numr++;
					}
					else if (k==Edown) {
						if (clevel.numr>1)
							clevel.numr--;
					}
				} while (k!=Eenter);
				printf("Number of columns\n");
				do {
					printf_xy(108,8,"%d ",clevel.numc);
					do k=ngetchx();while (k!=Eup&&k!=Edown&&k!=Eenter);
					if (k==Eup) {
						if (clevel.numc<30)
							clevel.numc++;
					}
					else if (k==Edown) {
						if (clevel.numc>1)
							clevel.numc--;
					}
				} while (k!=Eenter);
				break;
			case Eenter:
				if (dm.row<255) {
					do {
						memcpy(&sav,&clevel,sizeof(level));
						memcpy(&psav,&dm,sizeof(player));
						k=playlevel();
						memcpy(&clevel,&sav,sizeof(level));
						memcpy(&dm,&psav,sizeof(player));
					} while (k==2);
				}
				else {
					message(" Where is\n Dudeman?");
					ngetchx();
				}
				break;
			case Eescape:
				k=editmenu();
				break;
		}
	} while (k!=Eescape);
}
void load() {
	FILE *f1;
	int k;
	unsigned char a,b;
	clrscr();
	printf("Any unsaved data will be\nlost. Press any key to\ncontinue, Esc to return");
	if ((k=ngetchx())==Eescape)
		return;
	clrscr();
	printf("Name of file\n");
	getsn(fname,18);
	f1=fopen(fname,"rb");
	if (!f1) {
		printf("\nFile not found");
		ngetchx();
		return;
	}
	fseek(f1,-7,SEEK_END);
	if (fgetc(f1)!=0||fgetc(f1)!='L'||fgetc(f1)!='p'||fgetc(f1)!='c'||fgetc(f1)!='k'||fgetc(f1)!=0||fgetc(f1)!=OTH_TAG) {
		printf("\nNot a level file");
		ngetchx();
		return;
	}
	fseek(f1,0,SEEK_SET);
	clrscr();
	a=fgetc(f1);
	do {
		printf("%c",a);
		a=fgetc(f1);
	} while (a);
	a=fgetc(f1);
	fclose(f1);
	printf("\nThere are %d levels in\nthis file. Load Level",a);
	b=0;
	k=0;
	while (k!=Eenter) {
		printf_xy(132,16,"%d",b+1);
		do k=ngetchx();while (k!=Eup&&k!=Edown&&k!=Eenter);
		switch (k) {
			case Eup:
				if (b<a-1)
					b++;
				break;
			case Edown:
				if (b>0)
					b--;
				break;
		}
	}
	loadlevel(b);
}
void message(const char *str) {
	unsigned char a,b=1,c,d;
	for (a=0;a<strlen(str);a++) {
		if (str[a]=='\n')
			b++;
	}
	ScrRectFill(&(SCR_RECT){{47,-(4*b-53),113,4*b+59}},full,A_NORMAL);
	ScrRectFill(&(SCR_RECT){{48,-(4*b-54),112,4*b+58}},full,A_REVERSE);
	a=0;
	c=0;
	d=0;
	while (str[a]) {
		while (str[a]!='\n'&&str[a]) {
			DrawChar(50+6*c,-(4*b-56)+8*d,str[a],A_NORMAL);
			c++;
			a++;
		}
		d++;
		c=0;
		if (str[a]=='\n')
			a++;
	}
}
void play(unsigned char pass) {
	int k=0;
	char msg[23],str[4];
	unsigned char level;
	dm.holding=0;
	if (pass) {
		clrscr();
		printf("Password: ");
		getsn(str,4);
		level=0;
		k=0;
		while (loadlevel(level)) {
			if (!strcmp(str,clevel.pass)) {
				level--;
				k=1;
				break;
			}
			level++;
		}
		if (!k)
			level=255;
	}
	else
		level=255;
	do {
		level++;
		if (!loadlevel(level)) {
			message("You have\nbeaten all\nthe levels");
			ngetchx();
			break;
		}
		setcam();
		disp(cam.row,cam.col);
		sprintf(msg,"Level %d\nPassword:\n%s",level+1,clevel.pass);
		message(msg);
		ngetchx();
		k=1;
		switch (playlevel()) {
			case 0:k=0;break;
			case 2:level--;break;
		}
	} while (k);
}
void save() {
	char pass[4],pname[30];
	FILE *f1;
	int k;
	short worked;
	unsigned char r,c;
	clrscr();
	printf("1 - Save as a new pack\n2 - Save to existing pack\n3 - return");
	do k=ngetchx();while (k<'1'||k>'3');
	if (k=='3')
		return;
	clrscr();
	printf("File Name - ");
	getsn(fname,18);
	if (k=='1') {
		printf("\nPack Name: ");
		getsn(pname,30);
		f1=fopen(fname,"wb");
		fprintf(f1,"%s",pname);
		fputc(0,f1);
		fputc(1,f1);
	}
	else {
		worked=EM_moveSymFromExtMem(SYMSTR(fname),HS_NULL);
		f1=fopen(fname,"rb+");
		if (!f1) {
			printf("\nThat file doesn't exist");
			ngetchx();
			return;
		}
		r=fgetc(f1);
		printf("\n");
		do {
			printf("%c",r);
			r=fgetc(f1);
		} while (r);
		r=fgetc(f1);
		fseek(f1,-1,SEEK_CUR);
		fputc(r+1,f1);
		fseek(f1,-7,SEEK_END);
		if (fgetc(f1)!=0||fgetc(f1)!='L'||fgetc(f1)!='p'||fgetc(f1)!='c'||fgetc(f1)!='k'||fgetc(f1)!=0||fgetc(f1)!=OTH_TAG) {
			printf("\nNot a level file");
			ngetchx();
			if (worked)
				EM_moveSymToExtMem(SYMSTR(fname),HS_NULL);
			return;
		}
		fseek(f1,-7,SEEK_END);
	}
	fputc(clevel.numr,f1);
	fputc(clevel.numc,f1);
	printf("\nPassword for level: ");
	memset(pass,0,4);
	getsn(pass,4);
	fwrite(pass,1,3,f1);
	for (r=0;r<clevel.numr;r++) {
		for (c=0;c<clevel.numc;c+=2)
			fputc((clevel.data[r][c]<<4)+clevel.data[r][c+1],f1);
	}
	fputc(0,f1);
	fputc('L',f1);
	fputc('p',f1);
	fputc('c',f1);
	fputc('k',f1);
	fputc(0,f1);
	fputc(OTH_TAG,f1);
	fclose(f1);
	EM_moveSymToExtMem(SYMSTR(fname),HS_NULL);
}
void setcam() {
	short r,c;
	r=dm.row-6;
	c=dm.col-10;
	if (clevel.numr-12-r<0)
		r=clevel.numr-12;
	if (clevel.numc-20-c<0)
		c=clevel.numc-20;
	if (r<0)
		r=0;
	if (c<0)
		c=0;
	cam.row=r;
	cam.col=c;
}
